unit ipunit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Spin,
  EnhCtrls ;

type
  TPanelDemoForm = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Memo1: TMemo;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn4: TBitBtn;
    Edit1: TEdit;
    RadioGroup1: TRadioGroup;
    SpinButton1: TSpinButton;
    SpinButton2: TSpinButton;
    Label3: TLabel;
    Label4: TLabel;
    ListBox1: TListBox;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Edit2: TEdit;
    Label5: TLabel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Panel3: TPanel;
    Bevel1: TBevel;
    Label6: TLabel;
    Bevel2: TBevel;
    Label7: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Memo1PosChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
  private
    { Private declarations }
    procedure Edit1Filter( Sender : TObject ) ;
  public
    { Public declarations }
    TheStr : string ;
  end;

var
  PanelDemoForm: TPanelDemoForm;

implementation

{$R *.DFM}
procedure TPanelDemoForm.BitBtn1Click(Sender: TObject);
var
  Image : TImage ;
begin
  if OpenDialog1.Execute then
  begin
    Image := TImage.Create( nil ) ;
    Image.Picture.LoadFromFile( OpenDialog1.FileName ) ;
    Panel3.Canvas.Draw( 0, 0, Image.Picture.Graphic ) ;
    Image.Free ;
  end;
end;

procedure TPanelDemoForm.BitBtn2Click(Sender: TObject);
begin
  Panel1.HiThere ;
end;

procedure TPanelDemoForm.FormCreate(Sender: TObject);
begin
  TheStr := '' ;

  BitBtn1.ChangeColor := clNavy ;
  BitBtn1.EnterChange := TRUE ;

  BitBtn2.ChangeColor := clRed ;
  BitBtn2.EnterChange := TRUE ;

  BitBtn3.PlaySound := TRUE ;
  BitBtn3.Sound := MB_ICONQUESTION ;

  Memo1.OnPosChange := Memo1PosChange ;
  Memo1.Row := 0 ;
  Memo1.Col := 0 ;

  Edit1.ErrBeep := TRUE ;
  Edit1.Sound := MB_ICONSTOP ;
  Edit1.OnFilter := Edit1Filter ;
end;

procedure TPanelDemoForm.Button1Click(Sender: TObject);
begin
  TheStr := TheStr + 'X' ;
  ListBox1.Items.Add( TheStr ) ;
end;

procedure TPanelDemoForm.Memo1PosChange(Sender: TObject);
begin
  Label1.Caption := Format( 'Row: %d', [Memo1.Row + 1] ) ;
  Label2.Caption := Format( 'Col: %d', [Memo1.Col + 1] ) ;
end;

procedure TPanelDemoForm.FormShow(Sender: TObject);
begin
  Memo1.OnPosChange( Memo1 ) ;
end;

procedure TPanelDemoForm.BitBtn4Click(Sender: TObject);
begin
  if Memo1.CanUndo then
    Memo1.Undo
  else
  begin
    MessageBeep( MB_ICONERROR ) ;
    ShowMessage( 'Can''t Undo!' ) ;
  end;
end;

procedure TPanelDemoForm.Edit1Filter( Sender : TObject ) ;
begin
  if Edit1.Text[Length( Edit1.Text )] in ['A'..'Z'] then
    MessageBeep( 0 ) ;

end;

procedure TPanelDemoForm.Edit1Change(Sender: TObject);
var
  idx : word ;
  bsp : string ;
begin
  idx := Pos( '-', Edit1.Text ) ;
  if idx > 1 then
  begin
    bsp := Edit1.Text ;
    System.Delete( bsp, idx, 1 ) ;
    Edit1.Text := bsp ;
    MessageBeep( 0 ) ;
  end;
end;

procedure TPanelDemoForm.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
    0 : Edit1.Alignment := taLeftJustify ;
    1 : Edit1.Alignment := taCenter ;
    2 : Edit1.Alignment := taRightJustify ;
  end;
end;

procedure TPanelDemoForm.SpinButton1DownClick(Sender: TObject);
begin
  Memo1.Col := Memo1.Col - 1 ;
end;

procedure TPanelDemoForm.SpinButton1UpClick(Sender: TObject);
begin
  Memo1.SetFocus ;
  Memo1.Col := Memo1.Col + 1 ;
end;

procedure TPanelDemoForm.SpinButton2UpClick(Sender: TObject);
begin
  Memo1.SetFocus ;
  Memo1.Row := Memo1.Row - 1 ;
end;

procedure TPanelDemoForm.SpinButton2DownClick(Sender: TObject);
begin
  Memo1.SetFocus ;
  Memo1.Row := Memo1.Row + 1 ;
end;

procedure TPanelDemoForm.Edit2Change(Sender: TObject);
begin
  Memo1.SetFocus ;
  Edit1.FilterChars := Edit2.Text ;
end;

end.
